
--Copyright (c) 1993 Ohio Board of Regents and the University of
--Cincinnati.  All Rights Reserved.


-- An example in the construction of petri nets using the vhdl design
-- entities and package of in this directory.  This example
-- instantiates a simple two-processor system sharing a single resource
-- across a common bus.  In this model, "transitions" commonly represent
-- events or actions while "places" represent conditions or states.

library petri;
use petri.petri.all;
entity petri_use is

end;


architecture demo of petri_use is

signal arc1, arc2, arc3, arc4, arc5, arc6,
       arc7, arc8, arc9, arc10, arc11, arc12,
       arc13, arc14, arc15, arc16, arc17, arc18,
       arc19, arc20, arc21, arc22, arc23, arc24, 
       arc25, arc26 : arc bus; 

component place_1_1

    generic (initial_marking : integer;
             place_name      : string;
             debug_cntrl     : debug := trace_tokens);

    port (in_arc1, out_arc1 : inout arc bus);

end component;

component place_1_2

    generic (initial_marking : integer;
             place_name      : string;
             debug_cntrl     : debug := trace_tokens);

    port (in_arc1, out_arc1, out_arc2 : inout arc bus );

end component;

       
component place_2_2

    generic (initial_marking : integer;
             place_name      : string;
             debug_cntrl     : debug := trace_tokens);

    port (in_arc1, in_arc2, out_arc1, out_arc2 : inout arc bus);

end component;

component place_3_2

    generic (initial_marking : integer;
             place_name      : string;
             debug_cntrl     : debug := trace_tokens);

    port (in_arc1, in_arc2, in_arc3, out_arc1, out_arc2 : inout arc bus);

end component;

component transition_1_1

    generic (transition_name : string;
             debug_cntrl     : debug := firing);

    port (in_arc1   : inout arc bus;
          out_arc1  : inout arc bus);

end component;

component transition_2_2

    generic (transition_name : string;
             debug_cntrl     : debug := firing);

    port (in_arc1, in_arc2   : inout arc bus;
          out_arc1, out_arc2 : inout arc bus);

end component;


for P1,P2, P3, P4, P5   : place_1_1 use entity work.place_1_1(structure);
for P6, P7              : place_1_1 use entity work.place_1_1(structure);
for P8		        : place_1_2 use entity work.place_1_2(structure);
for P9 		        : place_2_2 use entity work.place_2_2(structure); 
for P10		        : place_3_2 use entity work.place_3_2(structure); 

for T1, T2, T3   : transition_2_2 use entity work.transition_2_2(structure);
for T4, T5, T6   : transition_2_2 use entity work.transition_2_2(structure);
for T7		 : transition_1_1 use entity work.transition_1_1(structure);


begin

P1 : place_1_1 
     generic map (1, "MU1")
     port map (arc2, arc1);
P2 : place_1_1
     generic map (1, "MU2")
     port map (arc4, arc3);
P3 : place_1_1 
     generic map (0, "P1")
     port map (arc5, arc6);
P4 : place_1_1
     generic map (0, "P2")
     port map (arc7, arc8);
P5 : place_1_1 
     generic map (0, "BUS3")
     port map (arc18, arc19);
P6 : place_1_1
     generic map (1, "BUS4")
     port map (arc20, arc21);
P7 : place_1_1 
     generic map (0, "RES1")
     port map (arc25, arc26);
P8 : place_1_2
     generic map (0, "BUS5")
     port map (arc22, arc23, arc24);
P9 : place_2_2 
     generic map (1, "BUS1")
     port map (arc9, arc10, arc11, arc12);
P10: place_3_2
     generic map (0, "BUS2")
     port map (arc13, arc14, arc15, arc16, arc17);
T1 : transition_2_2
     generic map ("tinst1")
     port map (arc1, arc11, arc5, arc13);
T2 : transition_2_2
     generic map ("tinst2")
     port map (arc3, arc12, arc7, arc14);
T3 : transition_2_2
     generic map ("tbus1")
     port map (arc16, arc19, arc20, arc22);
T4 : transition_2_2
     generic map ("tbus2")
     port map (arc17, arc21, arc18, arc25);
T5 : transition_2_2
     generic map ("tbus3")
     port map (arc6, arc23, arc2, arc9);
T6 : transition_2_2
     generic map ("tbus4")
     port map (arc8, arc24, arc4, arc10);
T7 : transition_1_1
     generic map ("tres")
     port map (arc26, arc15);

end;
